package TemplateRefer::CMS;

use strict;
use MT::Template;
use MT::TemplateRefer;

sub MYNAME { my ($myname) = __PACKAGE__ =~ /(\w+)::/; $myname; }

sub instance { MT->component(&MYNAME); }



###
sub template_source_edit_template {
    my ($cb, $app, $tmpl) = @_;

    my $old = quotemeta (<<'HTMLHEREDOC');
    <mt:if name="have_includes">
HTMLHEREDOC
    my $new = &instance->translate_templatized (<<'HTMLHEREDOC');
<mt:if name="refer_loop"><mtapp:widget
    id="template-refer"
    label="<__trans phrase="Referred Templates">">
<ul><mt:loop name="refer_loop">
    <li><a href="<mt:var name="refer_link">" class="icon-right icon-related"><mt:var name="refer_module" escape="html"></a></li>
</mt:loop></ul>
</mtapp:widget></mt:if>
HTMLHEREDOC
    $$tmpl =~ s/($old)/$new$1/;
}

### MT::App::CMS::template_param.edit_template
sub template_param_edit_template {
    my ($cb, $app, $param) = @_;
    my $src_id = $param->{id}
        or return; # do nothing

    # Clear
    map { $_->remove; } MT::TemplateRefer->load({ src_id => $src_id });
    # Remap
    foreach (@{$param->{include_loop}}, @{$param->{widget_loop}}, @{$param->{widget_set_loop}}) {
        if ($_->{include_link}) {
            my ($dst_id) = $_->{include_link} =~ /[&;]id=(\d+)/;
            my $refer = MT::TemplateRefer->new;
            $refer->src_id ($src_id);
            $refer->dst_id ($dst_id);
            $refer->save;
        }
    }

    # Referred Templates
    my @refer_loop;
    map {
        if (defined (my $src = MT::Template->load ({ id => $_->src_id }))) {
            push @refer_loop, {
                refer_link => $app->mt_uri (
                    mode => 'view',
                    args => {
                        blog_id => $src->blog_id || 0,
                        id      => $src->id,
                        '_type' => 'template',
                    }
                ),
                refer_module => $src->name,
            }
        }
        else {
            $_->remove; # no more exists
        }
    } MT::TemplateRefer->load ({ dst_id => $src_id });
    $param->{refer_loop} = \@refer_loop if @refer_loop;
}

### MT::Template.pre_remove
sub pre_remove {
    my ($cb, $tmpl) = @_; map { $_->remove; } MT::TemplateRefer->load({ src_id => $tmpl->id });
}

1;